#include "widget.h"
#include "ui_widget.h"

#include <QUrl>
#include <QMultiMap>
#include <iostream>

Widget::Widget(QWidget *parent) :
        QWidget(parent),
        ui(new Ui::Widget)
{
    ui->setupUi(this);

    // Recuperation de la surface pour le player
    QWidget *playerSurface = qFindChild<QWidget*>(this, "widget");
    QWidget *volumeSlider = qFindChild<QWidget*>(this, "volume");
    QWidget *seekSlider = qFindChild<QWidget*>(this, "seek");
    QPushButton *fullScreen = qFindChild<QPushButton*>(this, "fs");
    QPushButton *play = qFindChild<QPushButton*>(this, "play");
    QPushButton *pause = qFindChild<QPushButton*>(this, "pause");
    QPushButton *stop = qFindChild<QPushButton*>(this, "stop");

    // Encapsuler les paths dans un fichier un media source
    // Bug connue ne convertie pas les &#38

    // Exemple 1
    Phonon::MediaSource msource("/Users/jeff/Desktop/True.Blood.S03E01.HDTV.XviD-NoTV.avi");
    msource.setAutoDelete(true);

    // Exemple 2
    //    QUrl path = QUrl::fromEncoded("file://localhost/Users/jeff/Music/iTunes/iTunes%20Media/Music/Kanye%20West/The%20College%20Dropout/08%20Never%20Let%20Me%20Down.mp3");
    //    Phonon::MediaSource msource(path);
    //    msource.setAutoDelete(true);


    // Definir le type de chaque source
    // Media Object
    this->_mobject = new Phonon::MediaObject(playerSurface);
    this->_mobject->setCurrentSource(msource);

    // Recuperation MetaData
    // Un peu trop basique mais bon marche
    //    QMultiMap<QString, QString> metaData = this->_mobject->metaData();
    //    QMultiMap<QString, QString>::iterator i = metaData.begin();
    //    while (i != metaData.end()) {
    //        std::cout << "Key: " << i.key().toStdString() << "\t\tValue: " << i.value().toStdString() << std::endl;
    //        ++i;
    //    }

    // Video Widget
    this->_vwidget = new Phonon::VideoWidget(playerSurface);

    // Faire le scaling de facon automique en fonction la taille et de sa modification
    Phonon::createPath(this->_mobject, this->_vwidget);

    // Audio Output
    this->_aouput = new Phonon::AudioOutput(Phonon::VideoCategory, playerSurface);
    Phonon::createPath(this->_mobject, this->_aouput);

    // Controles
    // Refaire les slider en bas niveau avec les thick et tt les informations disponible

    // Slider
    this->_vslider = new Phonon::VolumeSlider(this->_aouput, volumeSlider);
    this->_sslider = new Phonon::SeekSlider(this->_mobject, seekSlider);

    // Button
    connect(fullScreen, SIGNAL(pressed()), _vwidget, SLOT(enterFullScreen()));
    connect(play, SIGNAL(pressed()), _mobject, SLOT(play()));
    connect(pause, SIGNAL(pressed()), _mobject, SLOT(pause()));
    connect(stop, SIGNAL(pressed()), _mobject, SLOT(stop()));
}

Widget::~Widget()
{
    delete ui;
}
